<?php
/****************
 * html.lib.php *
 ****************/
 
# Copyright:
#
# You may use freely this script, class or functions.
# I hope you'll respect the author's intellectual property by
# --- keeping this notice in your source
# --- setting a link to the author of these PHP scripts:
# --- dropping a note to the author:
#
# Author:    cagrET <cagret at gmail.com>
# Homepage:  http://www.gosu.pl/mgc/

function check_html($text)
/* obcina tagi,entery - nie zamienia linkow i enterow ( check_safe, check_nosafe) */
{
  $text = trim($text);
  $text = check_tags($text);
  return preg_replace("#(\r\n|\n|\r)#", "", $text);
} //end func


function check_tags($text)
{
  $search = array('<','>');
  $replace = array('&lt;','&gt;');
  return str_replace($search, $replace, $text);
} //end func


function check_spaces($text)
{
  return str_replace(' ','&nbsp;',$text);
} //end func


function check_safe($text)
/* obrobka textu na przyjazny htmlowi - bezpieczne
   funkcja dla zwyklych uzytkownikow - dla adminow `check_nosafe`
*/
{
  $text = trim($text);
  $text = check_tags($text);
  $text = search_links($text);
  return nl2br($text);
} //end func


function check_nosafe($text)
/* obrobka textu na przyjazny htmlowi - nie obcina `<` i `>`
   funkcja dla adminow
*/
{
  $text = trim($text);
  $text = search_links($text);
  return nl2br($text);
} //end func


function check_undo($text)
/* odwraca dzialanie wczesniejszych obrobek w texcie  - zamiany linkow oraz <br /> na '' */
{
  $text = preg_replace("#<a target=_blank href=\"http://www\.(.*?)\">www\.(.*?)</a>#i", "www.\\1", $text);
  $text = preg_replace("#<a target=_blank href=\"http://([a-z0-9\.]+)\.([a-z0-9\-]+)\.([a-z]{2,3})\">([a-z0-9\.]+)\.([a-z0-9\-]+)\.([a-z]{2,3})</a>#i", "\\1.\\2.\\3", $text);
  $text = preg_replace("#<a target=_blank href=\"(.*?)\">.*?</a>#i", "\\1", $text);
  $text = preg_replace("#<a href=mailto:(.*?)>.*?</a>#i", "\\1", $text);

  $search = array('&', '"');
  $replace = array('&amp;', '&quot;');
  $text = str_replace($search, $replace, $text);

  return str_replace('<br />','',$text);
} //end func


function search_links($text)
/* wyszukiwanie i zamiana linkow */
{
  $ret = " " . $text . " ";
  $ret = preg_replace("#([\n ])([a-z]+?)://([^ \r\n]+)#i", "\\1<a target=_blank href=\"\\2://\\3\">\\2://\\3</a>", $ret);
  $ret = preg_replace("#([\n ])www\.([a-z0-9\-]+)\.([a-z0-9\-.\~]+)((?:/[^ \r\n]*)?)#i", "\\1<a target=_blank href=\"http://www.\\2.\\3\\4\">www.\\2.\\3\\4</a>", $ret);
  $ret = preg_replace("#([\n ])([a-z0-9\.]+)\.([a-z0-9\-]+)\.([a-z]{2,3})([^a-z0-9])#i", "\\1<a target=_blank href=\"http://\\2.\\3.\\4\">\\2.\\3.\\4</a>\\5", $ret);
  $ret = preg_replace("#([\n ])([a-z0-9\-_.]+?)@([^, \r\n]+)(\.)([^, \r\n]+)#i", "\\1<a href=\"mailto:\\2@\\3\\4\\5\">\\2@\\3\\4\\5</a>", $ret);
  $ret = substr($ret, 0, -1);
  return substr($ret, 1);
} //end func


function JavaSafe($text)
/* funkcja zamienia text (juz wczesniej zamieninony na safe html) tak
   aby mozna go bylo wypisac na stronie w funkcji JavaScript funkcja('text')
   obcina ' i \ i \r\n
   zamieniamy tylko podczas wyswietlania dokumentu html !
*/
{
  $text = addcslashes($text, '\\');
  $text = addcslashes($text, '\'');
  return preg_replace("#(\r\n|\n|\r)#", "", $text);
} //end func

?>
