<?php
/*
 * etphp/classes/forum.class.php
 * ------------------------------------------------------------
 * Type:      PHP/MySQL
 * Name:      MyGosuClan
 * Version:   1.04
 * License:   GNU GPL
 * Author:    cagrET (Cezary Tomczak)
 * Homepage:  http://www.gosu.pl/mgc/
 * E-mail:    cagret at gmail.com
 * ------------------------------------------------------------
 */

class forum {
 var $db;     //referece to mysql class resource
 var $smarty;  //reference to smarty class resource
 var $show;  //show x topics
 
 var $tbl_topics = array();  //topics table from database
 var $tbl_posts = array();  //posts table from database

 var $tid;  //topic id
 
 var $error = array();  //if any error occurs
 
 function forum($db, $smarty, $show)
 {
   include 'init/lib/time.lib.php';
   include 'init/lib/html.lib.php';
   include 'init/lib/files.lib.php';

   #-- initial vars
   $this->db = &$db;
   $this->smarty = &$smarty;
   $this->show = (int) $show;

   $this->tid = (int) get_param('tid');
   $this->pid = (int) get_param('pid');
   $mod = get_param('mod');
   
   #-- add_topic OR add_post OR edit post
   if(post_param('submit_add_topic')) $this->add_topic();
   if(post_param('submit_add_post')) $this->add_post();
   if(post_param('submit_edit_post')) $this->edit_post();
   
   #-- query database
   if($this->pid && $mod == 'edit') $this->get_edit_post();
   else
   {
     $this->get_topics();
     if($this->tid) $this->get_posts();
   }
   
   #-- template vars
   $this->smarty->assign_by_ref('tid', $this->tid);
   $this->smarty->assign_by_ref('pid', $this->pid);

   $this->smarty->assign_by_ref('tbl_topics', $this->tbl_topics);
   $this->smarty->assign_by_ref('tbl_posts', $this->tbl_posts);
   $this->smarty->assign_by_ref('tbl_edit', $this->tbl_edit);
   
   #-- display
   if($this->pid && $mod == 'edit') $smarty->display('forum/edit_post.tpl');
   elseif($this->tid) $this->smarty->display('forum/topic.tpl');
   else $this->smarty->display('forum/forum.tpl');
 } //end func
 
 function get_topics()
 {
   $page = (int) get_param('page');

   if($this->tid)
   {
     if(!$this->topic_exists()) $this->tid = 0;
   }
   else
   {
     #-- counting pages
     $this->db->query("select COUNT(*) from ".prefix."forum");
     $this->db->next_record();
     $pages = ceil($this->db->Record['COUNT(*)'] / $this->show);
     
     if ($page < 1) $page = 1;
     if ($page > $pages) $page = $pages;
     $start = $page * $this->show - $this->show;
	 if ($start < 0) {
		$start = 0;
	 }
     $this->smarty->assign('page', $page);

     #-- `next page` and `previous page` links
     $next = 0; $prev = 0;
     if($page >= 1 && $page < $pages) $next = $page + 1;
     if($page > 1 && $page <= $pages) $prev = $page - 1;

     #-- smarty vars
     $this->smarty->assign('next', $next);
     $this->smarty->assign('prev', $prev);
     $this->smarty->assign('pages', $pages);
     
     #-- query
     $this->db->query("select * from ".prefix."forum order by date desc limit $start,{$this->show}");
   }

   #-- query results to variable
   while($this->db->next_record()) {
     $this->db->Record['date'] = ShortDate($this->db->Record['date']);
     $this->tbl_topics[] = $this->db->Record;
   }
 } //end func
 
 function get_posts()
 {
   #-- query
   $this->db->query("select * from ".prefix."forum_posts where tid='{$this->tid}' order by pid");
   
   #-- query results to variable
   while($this->db->next_record()) $this->tbl_posts[] = $this->db->Record;
 } //end func
 
 function get_edit_post()
 {
   if(! ($GLOBALS['access']['posts_edit']) ) return 0;

   $this->db->query("select * from ".prefix."forum_posts where pid='{$this->pid}'");
   $this->db->next_record();
   $this->tbl_edit = $this->db->Record;
   $this->tbl_edit['ip_name'] = @gethostbyaddr($this->tbl_edit['ip']);
   $this->tbl_edit['text'] = check_undo($this->tbl_edit['text']);
   $this->tbl_edit['text'] = undo_edit_post($this->tbl_edit['text']);
 } //end func
 
 function add_topic()
 {
   if(! ($_SESSION['mgc']['auth'] >= $GLOBALS['auth']['member']) ) return 0;

   #-- post variables - form
   $post_title = check_html(post_param('title'));
   if($_SESSION['mgc']['auth'] >= $GLOBALS['auth']['admin']) $post_text = check_nosafe(post_param('text'));
   else $post_text = check_safe(post_param('text'));
   
   #-- if not empty form fields
   if(!$post_title) $this->error[] = 'title';
   if(!$post_text) $this->error[] = 'text';
   
   #-- last topic created by user
   $this->db->query("select MAX(tid) from ".prefix."forum where uid='{$_SESSION['mgc']['uid']}'");
   $this->db->next_record();
   $max = $this->db->Record['MAX(tid)'];
   
   #-- if last topic is the same - double post
   $this->db->query("select * from ".prefix."forum where tid='$max' and title='$post_title'");
   if($this->db->num_rows() != 0) $this->error[] = 'double';
   
   #-- if any errors
   if($this->error) { $_GET['mod'] = 'addtopic'; return 0; }

   $date = TimeToDate(time());
   $ip = get_ip();
     
   #-- add topic
   $this->db->query("insert into ".prefix."forum set title='$post_title', date='$date', uid='{$_SESSION['mgc']['uid']}', user='{$_SESSION['mgc']['user']}', luid='{$_SESSION['mgc']['uid']}', luser='{$_SESSION['mgc']['user']}', posts='1', ip='$ip'");
   $tid = mysql_insert_id($this->db->Link_ID);
     
   #-- add post
   if($this->db->Query_ID) {
     $this->db->query("insert into ".prefix."forum_posts set tid='$tid', uid='{$_SESSION['mgc']['uid']}', user='{$_SESSION['mgc']['user']}', date='$date', text='$post_text', ip='$ip'");
   }
 } //end func
 
 function add_post()
 {
   if(! ($_SESSION['mgc']['auth'] >= $GLOBALS['auth']['member']) ) return 0;
   
   #-- post vars - form
   $post_text = check_safe(post_param('text'));

   #-- if empty fields
   if(!$post_text) $this->error[] = 'text';

   #-- if topic exists
   if(!$this->topic_exists()) return 0;

   #-- last post of this user
   $this->db->query("select MAX(pid) from ".prefix."forum_posts where uid='{$_SESSION['mgc']['uid']}'");
   $this->db->next_record();
   $max = $this->db->Record['MAX(pid)'];

   #-- if last post is the same - double post
   $this->db->query("select * from ".prefix."forum_posts where pid='$max' and text='$post_text'");
   if($this->db->num_rows() != 0) $this->error[] = 'double';

   #-- if any errors
   if($this->error) return 0;

   $date = TimeToDate(time());
   $ip = get_ip();
     
   #-- add post
   $this->db->query("insert into ".prefix."forum_posts set tid='{$this->tid}', uid='{$_SESSION['mgc']['uid']}', user='{$_SESSION['mgc']['user']}', date='$date', text='$post_text', ip='$ip'");
     
   #-- change topic: posts,last uid,last user,date
   if($this->db->Query_ID) {
     $this->db->query("update ".prefix."forum set posts=posts+1, luid='{$_SESSION['mgc']['uid']}', luser='{$_SESSION['mgc']['user']}', date='$date' where tid='{$this->tid}'");
   }
 } //end func
 
 function edit_post()
 {
   if(! ($GLOBALS['access']['posts_edit']) ) return 0;

   $text = check_nosafe(post_param('text'));
   $text = $text . edit_post($_SESSION['mgc']['user'], TimeToDate(time()));

   $this->db->query("update ".prefix."forum_posts set text='$text' where pid='{$this->pid}'");
 } //end func
 
 function topic_exists()
 {
   $this->db->query("select * from ".prefix."forum where tid='{$this->tid}'");
   if($this->db->num_rows() == 1) return 1;
   return 0;
 } //end func
 
}
?>
