<?php
/*
 * modules/users/inc.Users.php
 * ------------------------------------------------------------
 * Type:      PHP/MySQL
 * Name:      MyGosuClan
 * Version:   1.04
 * License:   GNU GPL
 * Author:    cagrET (Cezary Tomczak)
 * Homepage:  http://www.gosu.pl/mgc/
 * E-mail:    cagret at gmail.com
 * ------------------------------------------------------------
 */

class users {
 var $db; //reference to mysql class resource
 var $smarty; //reference to smarty class resource

 var $tbl_user = array();
 var $tbl_users = array();

 var $uid;  //user id
 var $mod; //mod
 
 var $error = array();
 
 function users($db, $smarty)
 {
   include 'init/lib/html.lib.php';
   include 'init/lib/validation.lib.php';

   $this->db = &$db;
   $this->smarty = &$smarty;
   
   $this->uid = (int) get_param('uid');
   $this->mod = get_param('mod');
   
   #-- mod
   if($this->mod == 'new' && post_param('submit_new_account')) $this->mod_new();
   elseif($this->mod == 'edit' && post_param('submit_users_edit')) $this->mod_edit();

   #-- get
   if($this->mod == 'edit') $this->get_edit();
   elseif(!$this->mod) $this->get_userinfo();

   #-- var
   $this->smarty->assign_by_ref('tbl_user', $this->tbl_user);
   $this->smarty->assign_by_ref('tbl_users', $this->tbl_users);
   $this->smarty->assign_by_ref('error', $this->error);
   
   #-- display
   if($this->mod == 'new') $this->smarty->display('users/new_account.tpl');
   elseif($this->mod == 'edit') $this->smarty->display('users/edit.tpl');
   else $this->smarty->display('users/userinfo.tpl');
   
 } //end func
 
 function get_edit()
 {
   $this->db->query("select * from ".prefix."users where uid='{$_SESSION['mgc']['uid']}'");
   $this->db->next_record();
   $this->tbl_users = $this->db->Record;
 } //end func

 function mod_edit()
 {
   $post_pass1   = trim(post_param('pass1'));
   $post_pass2   = trim(post_param('pass2'));
   
   $post_email   = check_html(post_param('email'));
   $post_icq     = check_html(post_param('icq'));
   $post_gg      = check_html(post_param('gg'));
   $post_website = check_html(post_param('website'));
   $post_scnick  = check_html(post_param('scnick'));

   $coded_pass = coded_pass($post_pass1);

   #-- if errors
   if(!$post_email || !is_email($post_email)) $this->error['email'] = 1;
   if($post_pass1 != $post_pass2) $this->error['pass'] = 1;
   
   if($this->error) return 0;

   $query = "update ".prefix."users set ";
   if($post_pass1) $query .= "pass='$coded_pass', ";
   $query .= "email='$post_email', icq='$post_icq', gg='$post_gg', website='$post_website', scnick='$post_scnick' where uid='{$_SESSION['mgc']['uid']}'";
   $this->db->query($query);
   $this->mod = '';
 } //end func

 function mod_new()
 {
   $post_user    = check_html(post_param('user'));
   $post_email   = post_param('email');
   $post_pass1   = trim(post_param('pass1'));
   $post_pass2   = trim(post_param('pass2'));
   $post_icq     = check_html(post_param('icq'));
   $post_gg      = check_html(post_param('gg'));
   $post_website = check_html(post_param('website'));
   $post_scnick  = check_html(post_param('scnick'));
   
   if(!$post_user) $this->error['user'] = 1;
   if(!$post_email || !is_email($post_email)) $this->error['email'] = 1;
   if(!$post_pass1 || !$post_pass2 || $post_pass1 != $post_pass2) $this->error['pass'] = 1;
   
   #-- if user with that nick exists
   $this->db->query("select * from ".prefix."users where user='$post_user'");
   if($this->db->num_rows() != 0) $this->error['user_exists'] = 1;
   
   #-- if ip banned
   if(ip_banned(get_ip())) $this->error['ip_banned'] = 1;
   
   #-- if error
   if($this->error) return 0;
   
   $coded_pass = coded_pass($post_pass1);
   $ip = get_ip();
   $active = 1;
   $auth = 1;
   if($GLOBALS['cfg']['activate_user'] == 1) $active = 0;
   
   #-- insert user
   $this->db->query("insert into ".prefix."users set user='$post_user', email='$post_email', pass='$coded_pass', auth='$auth', active='$active', time=unix_timestamp(), ip='$ip', icq='$post_icq', gg='$post_gg', website='$post_website', scnick='$post_scnick'");

 } //end func
 
 function get_userinfo()
 {
   $this->get_allusers();
   
   $uid = $this->uid;
   if($uid <= 0) $uid = $_SESSION['mgc']['uid'];
   if($uid <= 0) {
     $this->db->query("select * from ".prefix."users order by uid desc limit 1");
     $this->db->next_record();
     $uid = $this->db->Record['uid'];
   }
   
   $this->db->query("select * from ".prefix."users where uid='$uid'");

   while($this->db->next_record()) $this->tbl_user[] = $this->db->Record;
 } //end func
 
 function get_allusers()
 {
   $this->db->query("select user,uid from ".prefix."users order by user");
   
   while($this->db->next_record()) $this->tbl_users[] = $this->db->Record;
 } //end func

}
?>
